package activemq.helloworld;


import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.DeliveryMode;
import javax.jms.Destination;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;

import org.apache.activemq.ActiveMQConnectionFactory;

public class Sender {

	public static void main(String[] args) throws Exception{
		//һConnectionFactoryҪû롢ԼҪӵĵַʹĬϼɣĬ϶˿"tcp://localhost:61616"
		ConnectionFactory connectionFactory = new ActiveMQConnectionFactory(
				"zx",
				"123456",
				"tcp://localhost:61616");
//		ڶͨConnectionFactoryǴһConnectionӣConnectionstartӣConnectionĬǹرյġ
		Connection connection = connectionFactory.createConnection();
		connection.start();
//		ͨConnection󴴽SessionỰڽϢһΪǷ񣬲ΪǩģʽһΪԶǩա
//		Session session = connection.createSession(Boolean.TRUE, Session.AUTO_ACKNOWLEDGE);
		Session session = connection.createSession(Boolean.TRUE, Session.CLIENT_ACKNOWLEDGE);
//		ĲͨSessionDestinationָһͻָϢĿϢԴĿ꣬PTPģʽУDestinationQueueУPub/SubģʽУDestinationΪTopic⡣ڳпʹöQueueTopic
		Destination desiDestination = session.createQueue("queue1");
//		岽ͨSession󴴽ͺͽն(ߺ)MessageProducer/MessageConsumer
		MessageProducer messageProducer = session.createProducer(null);
//		ǿʹMessageProducersetDeliveryModeΪó־Ժͷǳ־ԡ
//		messageProducer.setDeliveryMode(DeliveryMode.NON_PERSISTENT);
//		߲ʹJMS淶TextMessageʽ(ͨSession)MessageProducersendݡͬͻʹreceiveнݡҪǹرConnection
		/*for(int i=0;i<5;i++){
			TextMessage textMessage = session.createTextMessage();
			textMessage.setText("Ϣ,idΪ"+i);
			//arg1:Ŀĵ
			//arg2:Ϣ
			//arg3:Ƿ־û
			//arg4:ȼ
			//arg5:ϢMQϵĴЧ
			messageProducer.send(desiDestination,textMessage,DeliveryMode.NON_PERSISTENT,i,1000*60*1);	
			System.out.println("Ϣ---"+i);
		}*/
		
		TextMessage textMessage1 = session.createTextMessage();
		textMessage1.setText("Ϣ1");
		messageProducer.send(desiDestination,textMessage1,DeliveryMode.PERSISTENT,1,1000*60*20);
		
		TextMessage textMessage2 = session.createTextMessage();
		textMessage2.setText("Ϣ8");
		messageProducer.send(desiDestination,textMessage2,DeliveryMode.PERSISTENT,8,1000*60*20);
		
		TextMessage textMessage3 = session.createTextMessage();
		textMessage3.setText("Ϣ4");
		messageProducer.send(desiDestination,textMessage3,DeliveryMode.PERSISTENT,4,1000*60*20);
		
		session.commit();
		
		if(connection!=null){
			connection.close();
		}
	}
	
}
